package ca.uwaterloo.cs.gmysql.data;

import java.util.Hashtable;

public class Row {

	public static   boolean						g_hash = false;
	public static	int							g_cnt  = 0;
	public static	Integer						g_tiny = null;
	public static	Hashtable<String,Integer>	g_ids  = new Hashtable<String,Integer>();
	public static	int							g_max_id_size = 0;
	public static 	String						g_id_type = null;

	public static String id(String value)
	{
		if (g_hash) {
			if (g_ids.get(value) == null) {
				g_tiny = new Integer(g_cnt);
				g_ids.put(value, g_tiny);
				++g_cnt;
			}
		} else {
			int lth = value.length();
			if (g_max_id_size < lth) {
				g_max_id_size = lth;
		}	}
		return value;
	}

	public static void sqlstring(String value)
	{
		int	i, lth;
		char	c;

		if (value == null) {
			System.out.print("null");
			return;
		} 
		System.out.print('\'');
		lth = value.length();
		for (i = 0; i < lth; ++i) {
			c = value.charAt(i);
			switch (c) {
			case '\\':
			case '\'':
				System.out.print('\\');
				break;
			case 0:
				System.out.print('\\');
				c = '0';
				break;
			case '\b':
				System.out.print('\\');
				c = 'b';
				break;
			case '\n':
				System.out.print('\\');
				c = 'n';
				break;
			case '\r':
				System.out.print('\\');
				c = 'r';
				break;
			case '\t':
				System.out.print('\\');
				c = 't';
				break;
			case 26:
				System.out.print('\\');
				c = 'Z';
				break;
			}
			System.out.print(c);
		}
		System.out.print('\'');
	}

	public static String idtype()
	{
		if (g_hash) {
			return "int unsigned not null";
		} else if (g_id_type == null) {
			System.err.println("Max id size " + g_max_id_size);
			if (g_max_id_size < 255) {
				g_max_id_size = 255;
			} else {
				g_max_id_size = (g_max_id_size + 1023 + 1023) & ~1023;
			}
			System.err.println("Max id size " + g_max_id_size);
			g_id_type = "varchar(" + g_max_id_size + ") not null";
		}
		return g_id_type;
	}

	public static void idstring(String value)
	{
		Integer	val;

		if (!g_hash) {
			sqlstring(value);
			return;
		}
		val = g_ids.get(value);
		System.out.print(val.intValue());
	}
}
